/* lab12a.c */

#include <stdlib.h>
#include <stdio.h>
#include <pthread.h>
#include <unistd.h>

#define I_MAX_VALOR     254
#define SZ_FORMATO      "Formato: p <#threads> <#iteracoes>\n"
#define SZ_MAX_THREADS  "O maximo de threads permitido e' %d.\n"
#define SZ_ERRO_CRIA    "Erro na criacao do thread %d.\n"
#define SZ_ERRO_MEM     "Erro de falta de memoria.\n"
#define SZ_NUM_THREADS  "Numero de threads que ficarao sendo criadas: %d.\n"
#define SZ_ITERACOES    "Numero total de iteracoes: %d.\n"
#define SZ_NASCENDO     "Thread %d nascendo na iteracao %d.\n"
#define SZ_SUICIDANDO   "Thread %d se suicidando na iteracao %d. Ahhhhhhhhhh!\n"
#define SZ_INCREMENT    "Thread %d na iteracao %d fazendo contador = %d.\n"


typedef void ( *Callback )( void* Parametro ) ;

typedef struct {
   Callback Funcao     ;
   int      iIdThread  ,
            n          ,
            iIteracoes ,
            iNumIter   ;
} tpParametro ;


int             iContador = 0                         ;
pthread_mutex_t MonExcMut = PTHREAD_MUTEX_INITIALIZER ;


void* fazalgo( void* Parametro ) ;

void proximaiteracao( tpParametro* Parametro ) ;

void Incrementar( void* Parametro ) ;


void* fazalgo( void* Parametro ) {
   tpParametro* pParametro = ( tpParametro* )Parametro ;
   int iTempo                                          ,
       iMeuId = pParametro->iIdThread                  ;

   iTempo = 1 + ( int )( ( double )pParametro->n * rand( )
                       / ( RAND_MAX + 1.0 ) ) ;
   sleep( iTempo ) ;
   pParametro->Funcao( Parametro ) ;

   printf( SZ_SUICIDANDO, iMeuId, pParametro->iIteracoes ) ;
   fflush( stdout ) ;

   free( Parametro ) ;
   pthread_exit( NULL ) ;
} /* fazalgo */


void proximaiteracao( tpParametro* Parametro ) {
   int          i                     ,
                iErro                 ;
   tpParametro* pParametro            ;
   pthread_t    Thread[ I_MAX_VALOR ] ;

   if ( Parametro->iIteracoes < Parametro->iNumIter ) {
      Parametro->iIteracoes++ ;

      for ( i = 0 ; i < Parametro->n ; i++ ) {
         printf( SZ_NASCENDO, i, Parametro->iIteracoes ) ;
         fflush( stdout ) ;

         pParametro = ( tpParametro* )malloc( sizeof( tpParametro ) ) ;
         pParametro->Funcao = Incrementar ;
         pParametro->iIdThread = i ;
         pParametro->iNumIter = Parametro->iNumIter ;
         pParametro->iIteracoes = Parametro->iIteracoes ;
         pParametro->n = Parametro->n ;
         iErro = pthread_create( &Thread[ i ], NULL, fazalgo,
                                                     ( void* )( pParametro ) ) ;

         if ( iErro != 0 ) {
            printf( SZ_ERRO_CRIA, i ) ;
            exit( 1 ) ;
         } /* if */
      } /* for */

   } /* if */

   free( Parametro ) ;
   pthread_exit( NULL ) ;
} /* proximaiteracao */


void Incrementar( void* Parametro ) {
   tpParametro* pParametro = ( tpParametro* )Parametro ;

   pthread_mutex_lock( &MonExcMut ) ;

   iContador++ ;
   printf( SZ_INCREMENT, pParametro->iIdThread, pParametro->iIteracoes,
                                                iContador ) ;
   fflush( stdout ) ;

   if ( iContador == pParametro->n ) {
      iContador = 0 ;
      pthread_mutex_unlock( &MonExcMut ) ;
      proximaiteracao( pParametro ) ;
   } /* if */

   pthread_mutex_unlock( &MonExcMut ) ;
} /* Incrementar */


int main( int   argc    ,
          char* argv[ ]  ) {

   tpParametro* pParametro = ( tpParametro* )malloc( sizeof( tpParametro ) ) ;

   if ( pParametro == NULL ) {
      printf( SZ_ERRO_MEM ) ;
      return 1 ;
   } /* if */

   if ( argc != 3 ) {
      printf( SZ_FORMATO ) ;
      return 0 ;
   } /* if */

   pParametro->n = atoi( argv[ 1 ] ) ;
   pParametro->iNumIter = atoi( argv[ 2 ] ) ;
   pParametro->iIteracoes = 0 ;
   pParametro->iIdThread = 0 ;

   if ( pParametro->n > I_MAX_VALOR ) {
      printf( SZ_MAX_THREADS, I_MAX_VALOR ) ;
      return 0 ;
   } /* if */

   printf( SZ_NUM_THREADS, pParametro->n ) ;
   printf( SZ_ITERACOES, pParametro->iNumIter ) ;
   fflush( stdout ) ;

   srand( time( NULL ) ) ;
   proximaiteracao( pParametro ) ;
   return 0 ;
}
